<template>
  <div class="app-container">
    <div class="search">
      <el-date-picker v-model="table.getdataListParm.parammaps.inputDatetime" class="inputDatetime filter-item" type="daterange" range-separator="至" start-placeholder="开始日期" end-placeholder="结束日期" style="width: 250px;" />
      <el-button class="el-icon-arrow-left elIconArrowLeft" @click="handleBefore" />
      <el-button class="el-icon-arrow-right elIconArrowRight" @click="handleNext" />
      <el-select v-model="table.getdataListParm.parammaps.barid" filterable placeholder="栏舍名称" class="filter-item" style="width: 120px;" clearable>
        <el-option v-for="item in houseNameList" :key="item.id" :label="item.bname" :value="item.id" />
      </el-select>

      <el-button class="successBorder" @click="form_search">查询</el-button>
      <el-button class="successBorder" @click="handleRefresh">重置</el-button>
    </div>
    <div class="operation">
      <el-button v-if="isRoleEdit" icon="el-icon-plus" class="success"  @click="handleCreate">新增</el-button>
      <el-button v-if="isRoleEdit" icon="el-icon-delete" class="danger"  @click="form_delete">删除</el-button>
      <!-- 临时注释 -->
      <!-- <el-button v-if="isRoleEdit" icon="el-icon-copy-document" class="copy" @click="handleCopy">复制</el-button> -->
      <!-- 临时注释 -->
      <el-upload v-if="isRoleEdit" style="float: right;" :headers="headers" :data="uploadData" :action="uploadExcelUrl" :show-file-list="false" :before-upload="beforeImport" :on-success="handleImportSuccess">
        <el-button class="import" icon="el-icon-download" style="float: right;">导入</el-button>
      </el-upload>
      <el-dropdown style="float: right;margin-right: 10px;">
        <el-button class="export" icon="el-icon-upload2">导出</el-button>
        <el-dropdown-menu slot="dropdown">
          <el-dropdown-item @click.native="handleExport(1)">导出模板</el-dropdown-item>
          <el-dropdown-item @click.native="handleExport(2)">导出数据</el-dropdown-item>
        </el-dropdown-menu>
      </el-dropdown>
      <el-button class="export" style="float: right;" @click="handleHistoryRecord">历史记录</el-button>
    </div>
    <div class="table">
      <el-table
        :key="table.tableKey"
        v-loading="table.listLoading"
        element-loading-text="给我一点时间"
        :data="table.list"
        border
        fit
        highlight-current-row
        style="width: 100%;"
        :row-style="rowStyle"
        :cell-style="cellStyle"
        class="elTable table-fixed"
        @selection-change="handleSelectionChange"
        :max-height="myHeight"
      >
        <el-table-column type="selection" align="center" width="50" />
        <el-table-column label="序号" align="center" type="index" width="50px">
          <template slot-scope="scope">
            <span>{{ scope.$index + (table.pageNum-1) * table.pageSize + 1 }}</span>
          </template>
        </el-table-column>
        <el-table-column label="栏舍名称" min-width="100px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.barname }}</span>
          </template>
        </el-table-column>
        <el-table-column label="第一层" align="center">
          <el-table-column prop="onerate" label="比例(%)" min-width="65px" align="center" />
          <el-table-column prop="oneweight" label="重量(g)" min-width="65px" align="center" />
        </el-table-column>
        <el-table-column label="第二层" align="center">
          <el-table-column prop="tworate" label="比例(%)" min-width="65px" align="center" />
          <el-table-column prop="twoweight" label="重量(g)" min-width="65px" align="center" />
        </el-table-column>
        <el-table-column label="第三层" align="center">
          <el-table-column prop="threerate" label="比例(%)" min-width="65px" align="center" />
          <el-table-column prop="threeweight" label="重量(g)" min-width="65px" align="center" />
        </el-table-column>
        <el-table-column label="备注" min-width="90px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.remark }}</span>
          </template>
        </el-table-column>
        <el-table-column label="操作人" min-width="90px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.emp }}</span>
          </template>
        </el-table-column>
        <el-table-column label="操作日期" min-width="90px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.operatetime }}</span>
          </template>
        </el-table-column>
        <el-table-column label="操作" align="center" width="80" class-name="small-padding fixed-width" fixed="right">
          <template slot-scope="{row}">
            <el-button v-if="isRoleEdit" icon="el-icon-edit-outline" class="miniSuccess" @click="handleUpdate(row)" />
            <span v-if="isRoleEdit" class="centerSpan">|</span>
            <el-button v-if="isRoleEdit" class="miniDanger" icon="el-icon-delete" @click="handleRowDelete(row)" />
          </template>
        </el-table-column>
      </el-table>
      <pagination v-show="table.total>=0" :total="table.total" :page.sync="table.getdataListParm.offset" :limit.sync="table.getdataListParm.pagecount" @pagination="getList" />
    </div>

    <!-- 新增/编辑 -->
    <el-dialog :fullscreen="dialogFull" v-if='create.dialogFormVisible' :visible.sync="create.dialogFormVisible" :close-on-click-modal="false" width="90%">
      <template slot="title">
        <div class="avue-crud__dialog__header">
          <span class="el-dialog__title">
            <span style="display:inline-block;width:3px;height:20px;margin-right:5px; float: left;margin-top:2px" />
            {{ textMap[create.dialogStatus] }}
          </span>
          <div class="avue-crud__dialog__menu" @click="dialogFull? dialogFull=false: dialogFull=true">
            <svg-icon v-if="dialogFull" icon-class="exit-fullscreen" />
            <svg-icon v-else icon-class="fullscreen" />
          </div>
        </div>
      </template>
      <div class="app-add">
        <el-form ref="temp" :rules="create.rules" :model="create.temp" label-position="right" label-width="150px" style="width: 100%;margin:0 auto 50px">
          <el-row>
            <el-col :span="24">
              <h3 style="width: 150px;text-align: right;">栏舍信息</h3>
            </el-col>
          </el-row>
          <el-row>
            <el-col v-if="create.dialogStatus=='create'" :span="8">
              <el-form-item label="栏舍名称：" prop="barid">
                <el-select ref="barid" v-model="create.temp.barid" filterable placeholder="栏舍名称" class="filter-item" style="width: 100%;" @change="changeBar">
                  <el-option v-for="item in houseNameList" :key="item.id" :label="item.bname" :value="item.id" />
                </el-select>
              </el-form-item>
            </el-col>
            <el-col v-else :span="8">
              <el-form-item label="栏舍名称：" prop="barname">
                <el-input ref="barname" v-model="create.temp.barname" disabled class="filter-item" placeholder="barname" />
              </el-form-item>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="24">
              <h3 style="width: 150px;text-align: right;">重量比例</h3>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="8">
              <el-form-item label="第一层重量（g）：" prop="oneweight">
                <el-input ref="oneweight" v-model="create.temp.oneweight" class="filter-item" placeholder="最多两位小数" type="number" step="0.01" style="width: 100%;" @blur="blurWeight" />
              </el-form-item>
            </el-col>
            <el-col :span="8">
              <el-form-item label="第二层重量（g）：" prop="twoweight">
                <el-input ref="twoweight" v-model="create.temp.twoweight" class="filter-item" placeholder="最多两位小数" type="number" step="0.01" style="width: 100%;" @blur="blurWeight" />
              </el-form-item>
            </el-col>
            <el-col :span="8">
              <el-form-item label="第三层重量（g）：" prop="threeweight">
                <el-input ref="threeweight" v-model="create.temp.threeweight" class="filter-item" placeholder="最多两位小数" type="number" step="0.01" style="width: 100%;" @blur="blurWeight" />
              </el-form-item>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="8">
              <el-form-item label="第一层比例 （%）:">
                <span>{{ create.temp.onerate }}</span>
                <span>{{ create.temp.onerange }}</span>
              </el-form-item>
            </el-col>
            <el-col :span="8">
              <el-form-item label="第二层比例 （%）:">
                <span>{{ create.temp.tworate }}</span>
                <span>{{ create.temp.tworange }}</span>
              </el-form-item>
            </el-col>
            <el-col :span="8">
              <el-form-item label="第三层比例 （%）:">
                <span>{{ create.temp.threerate }}</span>
                <span>{{ create.temp.threerange }}</span>
              </el-form-item>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="24">
              <h3 style="width: 150px;text-align: right;">操作详情</h3>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="8">
              <el-form-item label="操作人：" prop="emp">
                <el-select ref="emp" v-model="create.temp.emp" filterable placeholder="操作人" class="filter-item" style="width: 100%;" @blur="blurEmp">
                  <el-option v-for="item in create.noteTakerList" :key="item.myId" :label="item.emp" :value="item.emp" />
                </el-select>
              </el-form-item>
            </el-col>
            <el-col :span="8">
              <el-form-item label="操作日期：" prop="operatetime">
                <el-date-picker v-model="create.temp.operatetime" :disabled="create.dialogStatus=='update'" type="date" placeholder="选择日期" format="yyyy-MM-dd" value-format="yyyy-MM-dd" style="width: 100%;" :clearable="false" @change="changeOperatetime" />
              </el-form-item>
            </el-col>
            <el-col :span="8">
              <el-form-item label="备注：" prop="remark">
                <el-input ref="remark" v-model="create.temp.remark" class="filter-item" placeholder="1-255字符" type="textarea" :autosize="{ minRows: 1.3, maxRows: 4}" maxlength="255" style="width: 100%;" />
              </el-form-item>
            </el-col>
          </el-row>
        </el-form>
        <div slot="footer" class="dialog-footer">
          <el-button class="cancelClose" @click="create.dialogFormVisible = false;getList()">关闭</el-button>
          <el-button v-if="create.dialogStatus==='create'" class="save" :disabled="isokDisable" @click="createDataAgain()">确认新增</el-button>
          <el-button v-if="create.dialogStatus==='create' || create.dialogStatus==='update'" class="save" :disabled="isokDisable" @click="create.dialogStatus==='create'?createData():updateData()">确认</el-button>
        </div>
      </div>
    </el-dialog>
    <!-- 历史记录 -->
    <el-dialog :fullscreen="dialogFull" :destroy-on-close="true" :visible.sync="historyRecord.dialogFormVisible" :close-on-click-modal="false" width="90%">
      <template slot="title">
        <div class="avue-crud__dialog__header">
          <span class="el-dialog__title">
            <span style="display:inline-block;width:3px;height:20px;margin-right:5px; float: left;margin-top:2px" />
            {{ textMap[historyRecord.dialogStatus] }}
          </span>
          <div class="avue-crud__dialog__menu" @click="dialogFull? dialogFull=false: dialogFull=true">
            <svg-icon v-if="dialogFull" icon-class="exit-fullscreen" />
            <svg-icon v-else icon-class="fullscreen" />
          </div>
        </div>
      </template>
      <div class="historyRecord">
        <keep-alive>
          <component :is="historyRecord.myComponent" ref="historyRecord" />
        </keep-alive>
        <div slot="footer" class="dialog-footer">
          <el-button class="cancelClose cancelClose1" @click="historyRecord.dialogFormVisible = false; ">关闭</el-button>
        </div>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { GetDataByName, PostDataByName, failproccess, ExecDataByConfig, GetDataByNames, checkButtons } from '@/api/common'
import Cookies from 'js-cookie'
import { parseTime, json2excel } from '@/utils/index.js'
import Pagination from '@/components/Pagination'
import { MessageBox } from 'element-ui'
import axios from 'axios'
import { getToken } from '@/utils/auth'
export default {
  name: 'FecalScreen',
  components: { Pagination },
  data() {
    return {
      dialogFull: false,
      isRoleEdit: [],
      requestParams: [
        { name: 'getBarListEnable', offset: 0, pagecount: 0, parammaps: { 'pastureid': Cookies.get('pastureid') }},
        { name: 'getSysoptEnable', offset: 0, pagecount: 0, parammaps: { 'pastureid': Cookies.get('pastureid'), 'inforname': 'times' }}
      ],
      houseNameList: [], // 栏舍名称
      frequencyList: [], // 班次

      table: {
        getdataListParm: {
          name: 'getDungsieveList',
          page: 1,
          offset: 1,
          pagecount: parseInt(Cookies.get('pageCount')),
          returntype: 'Map',
          parammaps: {
            pastureid: Cookies.get('pastureid'),
            barid: '',
            times: '',
            startTime: '',
            stopTime: '',
            inputDatetime: ''
          }
        },
        tableKey: 0,
        list: [],
        total: 0,
        listLoading: true,
        temp: {}
      },

      // 新增/编辑
      create: {
        dialogFormVisible: false,
        dialogStatus: '',
        temp: { pastureid: Cookies.get('pastureid'), operatetime: parseTime(new Date(), '{y}-{m}-{d}'), emp: Cookies.get('employename'), barid: '', barname: '', times: '', oneweight: '', twoweight: '', threeweight: '', onerate: '', tworate: '', threerate: '', tworange: '', threerange: '', remark: '', ccid: '', ccname: '' },
        rules: {
          barid: [{ type: 'string', required: true, message: '必填', trigger: 'blur' }],
          oneweight: [{ type: 'string', required: true, message: '必填', trigger: 'blur' }],
          twoweight: [{ type: 'string', required: true, message: '必填', trigger: 'blur' }],
          threeweight: [{ type: 'string', required: true, message: '必填', trigger: 'blur' }]
        },
        // 操作人
        getdataListParm: {
          name: 'getDungsieveEmpHis',
          page: 1,
          offset: 1,
          pagecount: 10,
          returntype: 'Map',
          parammaps: {
            pastureid: Cookies.get('pastureid')
          }
        },
        // 宾州筛范围
        getdataListParm2: {
          name: 'getDungsieveRange',
          page: 1,
          offset: 1,
          pagecount: 1,
          returntype: 'Map',
          parammaps: {
            pastureid: Cookies.get('pastureid'),
            barid: '',
            date: ''
          }
        },
        noteTakerList: [] // 记录人
      },
      textMap: {
        create: '新增',
        update: '编辑',
        historyRecord: '历史记录'
      },
      historyRecord: {
        dialogFormVisible: false,
        dialogStatus: '',
        myComponent: null
      },
      requestParam: {},
      requestParam2: {},
      download: {
        getdataListParm: {
          name: 'getDungsieveList',
          page: 1,
          offset: 1,
          pagecount: 0,
          returntype: 'Map',
          parammaps: {
            pastureid: Cookies.get('pastureid'),
            barid: '',
            times: '',
            startTime: '',
            stopTime: '',
            inputDatetime: ''
          }
        },
        list: []
      },
      isokDisable: false,
      selectList: [],
      rowStyle: { maxHeight: 30 + 'px', height: 30 + 'px' },
      cellStyle: { padding: 0 + 'px' },
      myHeight:document.documentElement.clientHeight - 85- 150 - 45
    }
  },
  computed: {
    // 设置请求头
    headers() {
      return {
        token: getToken()
      }
    },
    uploadData() {
      return {
        name: 'checkbarname,insertDungsieveUpload',
        importParams: '栏舍名称,第一层重量（g）,第二层重量（g）,第三层重量（g）,备注,操作人,操作日期',
        sheetname: 'Sheet1',
        // 登录牧场
        pastureid: Cookies.get('pastureid'),
        // 日期参数
        dateParams: '操作日期',
        // 必填参数
        requiredParams: '栏舍名称,第一层重量（g）,第二层重量（g）,第三层重量（g）',
        // 为数值的参数
        numParams: '第一层重量（g）,第二层重量（g）,第三层重量（g）'
      }
    },
    // 设置上传地址
    uploadExcelUrl() {
      return Cookies.get('url') + 'authdata/ImportExcel'
    }
  },
  created() {
    this.getList()
    this.getDownList()
    this.getButtons()
  },

  methods: {
    getButtons() {
      const Edit = 'FecalScreen'
      const isRoleEdit = checkButtons(JSON.parse(sessionStorage.getItem('buttons')), Edit)
      this.isRoleEdit = isRoleEdit
    },
    getDownList() {
      GetDataByNames(this.requestParams).then(response => {
        this.houseNameList = response.data.getBarListEnable.list
        if (response.data.getSysoptEnable.list !== null) {
          for (let i = 1; i <= response.data.getSysoptEnable.list[0].inforvalue; i++) {
            const obj = {}
            obj.id = String(i)
            if (i == 1) { obj.name = '第一班' } else if (i == 2) { obj.name = '第二班' } else if (i == 3) { obj.name = '第三班' } else if (i == 4) { obj.name = '第四班' }else if (i == 5) { obj.name = '第五班' }else if (i == 6) { obj.name = '第六班' }
            this.frequencyList.push(obj)
          }
        } else {
          this.frequencyList = []
        }
      })
    },
    handleBefore() {
      if (this.table.getdataListParm.parammaps.inputDatetime !== '' && this.table.getdataListParm.parammaps.inputDatetime !== null) {
        var start = new Date(this.table.getdataListParm.parammaps.inputDatetime[0].setDate(this.table.getdataListParm.parammaps.inputDatetime[0].getDate() - 1))
        var stop = new Date(this.table.getdataListParm.parammaps.inputDatetime[1].setDate(this.table.getdataListParm.parammaps.inputDatetime[1].getDate() - 1))
        this.table.getdataListParm.parammaps.inputDatetime.length = 0
        this.table.getdataListParm.parammaps.inputDatetime.push(start, stop)
        this.$forceUpdate()
      }
    },
    handleNext() {
      if (this.table.getdataListParm.parammaps.inputDatetime !== '' && this.table.getdataListParm.parammaps.inputDatetime !== null) {
        var start = new Date(this.table.getdataListParm.parammaps.inputDatetime[0].setDate(this.table.getdataListParm.parammaps.inputDatetime[0].getDate() + 1))
        var stop = new Date(this.table.getdataListParm.parammaps.inputDatetime[1].setDate(this.table.getdataListParm.parammaps.inputDatetime[1].getDate() + 1))
        this.table.getdataListParm.parammaps.inputDatetime.length = 0
        this.table.getdataListParm.parammaps.inputDatetime.push(start, stop)
        this.$forceUpdate()
      }
    },
    getList() {
      this.table.listLoading = true
      GetDataByName(this.table.getdataListParm).then(response => {
        console.log('table数据', response.data.list)
        if (response.data.list !== null) {
          this.table.list = response.data.list
          this.table.pageNum = response.data.pageNum
          this.table.pageSize = response.data.pageSize
          this.table.total = response.data.total
        } else {
          this.table.list = []
        }
        setTimeout(() => {
          this.table.listLoading = false
        }, 100)
      })
    },
    form_search() {
      console.log('点击了查询')
      if (this.table.getdataListParm.parammaps.inputDatetime !== '' && this.table.getdataListParm.parammaps.inputDatetime !== null) {
        this.table.getdataListParm.parammaps.startTime = parseTime(this.table.getdataListParm.parammaps.inputDatetime[0], '{y}-{m}-{d}')
        this.table.getdataListParm.parammaps.stopTime = parseTime(this.table.getdataListParm.parammaps.inputDatetime[1], '{y}-{m}-{d}')
      } else {
        this.table.getdataListParm.parammaps.inputDatetime = ''
        this.table.getdataListParm.parammaps.startTime = ''
        this.table.getdataListParm.parammaps.stopTime = ''
      }
      this.table.getdataListParm.offset = 1
      this.getList()
    },
    handleRefresh() {
      console.log('点击了重置')
      this.table.getdataListParm.parammaps.barid = ''
      this.table.getdataListParm.parammaps.times = ''
      this.table.getdataListParm.parammaps.startTime = ''
      this.table.getdataListParm.parammaps.stopTime = ''
      this.table.getdataListParm.parammaps.inputDatetime = ''
      this.table.getdataListParm.offset = 1
      this.getList()
    },

    // 新增
    resetTemp() {
      this.create.temp = { pastureid: Cookies.get('pastureid'), operatetime: parseTime(new Date(), '{y}-{m}-{d}'), emp: Cookies.get('employename'), barid: '', barname: '', times: '', oneweight: '', twoweight: '', threeweight: '', onerate: '', tworate: '', threerate: '', tworange: '', threerange: '', remark: '', ccid: '', ccname: '' }
    },
    blurEmp(item) {
      this.create.temp.emp = item.target.value
    },
    // 栏舍名称
    changeBar(item) {
      this.create.temp.barname = this.houseNameList.find(obj => obj.id === item).bname
      this.getRange()
    },
    changeOperatetime() {
      this.getRange()
    },
    //  粪便筛范围
    getRange() {
      this.create.getdataListParm2.parammaps.date = this.create.temp.operatetime
      this.create.getdataListParm2.parammaps.barid = this.create.temp.barid
      GetDataByName(this.create.getdataListParm2).then(response => {
        if (response.data.list !== null) {
          this.create.temp.onerange = response.data.list[0].oneRange
          this.create.temp.tworange = response.data.list[0].twoRange
          this.create.temp.threerange = response.data.list[0].threeRange
          this.create.temp.ccid = response.data.list[0].ccid
          this.create.temp.ccname = response.data.list[0].ccname
        } else {
          this.create.temp.onerange = ''
          this.create.temp.tworange = ''
          this.create.temp.threerange = ''
          this.create.temp.ccid = ''
          this.create.temp.ccname = ''
        }
      })
    },
    // 操作人
    getNoteTakerList() {
      GetDataByName(this.create.getdataListParm).then(response => {
        if (response.data.list !== null) {
          for (let i = 0; i < response.data.list.length; i++) {
            response.data.list[i].myId = i
          }
          this.create.noteTakerList = response.data.list
          console.log('记录人数据', response.data.list)
          console.log(this.create.noteTakerList)
        } else {
          this.create.noteTakerList = []
        }
      })
    },

    blurWeight() {
      if (this.create.temp.oneweight && this.create.temp.twoweight && this.create.temp.threeweight) {
        const weightSum = parseFloat(this.create.temp.oneweight) + parseFloat(this.create.temp.twoweight) + parseFloat(this.create.temp.threeweight)
        this.create.temp.onerate = (parseFloat(this.create.temp.oneweight) / weightSum * 100).toFixed(2)
        this.create.temp.tworate = (parseFloat(this.create.temp.twoweight) / weightSum * 100).toFixed(2)
        this.create.temp.threerate = (100 - this.create.temp.onerate - this.create.temp.tworate).toFixed(2)
      }
    },

    handleCreate() {
      console.log('点击了新增')
      this.resetTemp()
      this.getNoteTakerList()
      this.dialogFull = false
      this.create.dialogStatus = 'create'
      this.create.dialogFormVisible = true
    },
    createData() {
      console.log('点击了新增保存')
      this.isokDisable = true
      setTimeout(() => {
        this.isokDisable = false
      }, 1000)
      this.$refs['temp'].validate(valid => {
        if (valid) {
          this.isokDisable = true
          setTimeout(() => {
            this.isokDisable = false
          }, 1000)
          const weight = /^\d+(\.\d{1,2})?$/
          // 第一层重量
          if (!weight.test(parseFloat(this.create.temp.oneweight)) || !weight.test(parseFloat(this.create.temp.twoweight)) || !weight.test(parseFloat(this.create.temp.threeweight))) {
            this.$message({ type: 'error', message: '重量不可小于0，最多保留俩位小数', duration: 2000 })
            return false
          }

          this.requestParam.name = 'insertDungsieve'
          this.requestParam.parammaps = this.create.temp
          if (this.create.temp.emp == '') { this.create.temp.emp = Cookies.get('employename') }
          PostDataByName(this.requestParam).then(response => {
            console.log('新增保存发送参数', this.requestParam)
            if (response.msg !== 'fail') {
              this.saveData()
            } else {
              const checkStr = new RegExp('Duplicate entry :pbto')
              if (checkStr.test(response.data)) {
                this.$notify({ title: '保存失败', message: '同一栏舍不可重复录入', type: 'warning', duration: 2000 })
              } else {
                this.$notify({ title: '保存失败', message: response.data, type: 'warning', duration: 2000 })
              }
            }
          })
        }
      })
    },
    saveData() {
      this.requestParam2.name = 'insertDungHistory'
      this.create.temp.pastureid = Cookies.get('pastureid')
      this.create.temp.changetime = parseTime(new Date(), '{y}-{m}-{d} {h}:{i}:{s}')
      this.create.temp.species = 'fps'
      this.create.temp.fourrate = ''
      this.create.temp.fourweight = ''
      this.requestParam2.parammaps = this.create.temp
      PostDataByName(this.requestParam2).then(response => {
        console.log('新增保存发送参数', this.requestParam1)
        if (response.msg !== 'fail') {
          this.$notify({ title: '成功', message: '保存成功', type: 'success', duration: 2000 })
          this.create.dialogFormVisible = false
          this.getList()
        } else {
          this.$notify({ title: '保存失败', message: response.data, type: 'warning', duration: 2000 })
        }
      })
    },
    createDataAgain() {
      console.log('点击了新增保存')
      this.isokDisable = true
      setTimeout(() => {
        this.isokDisable = false
      }, 1000)
      this.$refs['temp'].validate(valid => {
        if (valid) {
          this.isokDisable = true
          setTimeout(() => {
            this.isokDisable = false
          }, 1000)
          const weight = /^\d+(\.\d{1,2})?$/
          // 第一层重量
          if (!weight.test(parseFloat(this.create.temp.oneweight)) || !weight.test(parseFloat(this.create.temp.twoweight)) || !weight.test(parseFloat(this.create.temp.threeweight))) {
            this.$message({ type: 'error', message: '重量不可小于0，最多保留俩位小数', duration: 2000 })
            return false
          }

          this.requestParam.name = 'insertDungsieve'
          this.requestParam.parammaps = this.create.temp
          if (this.create.temp.emp == '') { this.create.temp.emp = Cookies.get('employename') }
          PostDataByName(this.requestParam).then(response => {
            console.log('新增保存发送参数', this.requestParam)
            if (response.msg !== 'fail') {
              this.saveData()
              this.resetTemp()
              this.getList()
              this.getNoteTakerList()
            } else {
              this.$notify({ title: '保存失败', message: response.data, type: 'warning', duration: 2000 })
            }
          })
        }
      })
    },

    // 编辑
    handleUpdate(row) {
      console.log('点击了编辑', row)
      row.barid = String(row.barid)
      this.create.temp = Object.assign({}, row)
      this.create.temp.id = row.id

      this.getNoteTakerList()
      this.dialogFull = false
      this.create.dialogStatus = 'update'
      this.create.dialogFormVisible = true
    },
    updateData() {
      this.isokDisable = true
      setTimeout(() => {
        this.isokDisable = false
      }, 1000)
      this.$refs['temp'].validate(valid => {
        if (valid) {
          this.isokDisable = true
          setTimeout(() => {
            this.isokDisable = false
          }, 1000)
          const weight = /^\d+(\.\d{1,2})?$/
          // 第一层重量
          if (!weight.test(parseFloat(this.create.temp.oneweight)) || !weight.test(parseFloat(this.create.temp.twoweight)) || !weight.test(parseFloat(this.create.temp.threeweight))) {
            this.$message({ type: 'error', message: '重量不可小于0，最多保留俩位小数', duration: 2000 })
            return false
          }

          this.requestParam.name = 'updateDungsieve'
          this.requestParam.parammaps = this.create.temp
          if (this.create.temp.emp == '') { this.create.temp.emp = Cookies.get('employename') }
          PostDataByName(this.requestParam).then(response => {
            console.log('新增保存发送参数', this.requestParam)
            if (response.msg !== 'fail') {
              this.saveData()
              this.getList()
            } else {
              this.$notify({ title: '保存失败', message: response.data, type: 'warning', duration: 2000 })
            }
          })
        }
      })
    },

    // 删除
    handleRowDelete(row) {
      console.log('点击了行内删除')
      MessageBox.confirm('是否确认删除此信息?', {
        confirmButtonText: '确认', cancelButtonText: '取消', type: 'warning'
      }).then(() => {
        this.selectList = []
        this.requestParam.name = 'deleteDungsieve'
        this.requestParam.parammaps = {}
        this.requestParam.parammaps.pastureid = row.pastureid
        this.requestParam.parammaps.id = row.id
        PostDataByName(this.requestParam).then(response => {
          if (response.msg === 'fail') {
            this.$notify({ title: '删除失败', message: response.data, type: 'warning', duration: 2000 })
          } else {
            this.$notify({ title: '成功', message: '删除成功', type: 'success', duration: 2000 })
            this.getList()
          }
        })
      }).catch(() => {
        this.$message({ type: 'info', message: '已取消删除' })
      })
    },
    handleSelectionChange(val) {
      console.log('勾选数据', val)
      this.selectList = val
    },
    form_delete() {
      console.log('点击了删除')
      if (this.selectList.length == 0) {
        this.$message({ type: 'error', message: '请选择粪便筛', duration: 2000 })
      } else {
        MessageBox.confirm('当前选中' + this.selectList.length + '条信息，是否删除?', {
          confirmButtonText: '确认', cancelButtonText: '取消', type: 'warning'
        }).then(() => {
          console.log(this.selectList)
          this.requestParam.common = { 'returnmap': '0' }
          this.requestParam.data = []
          this.requestParam.data[0] = { 'name': 'insertSpotList', 'resultmaps': { 'list': this.selectList }}
          this.requestParam.data[0].children = []
          this.requestParam.data[0].children[0] = { 'name': 'deleteDungsieve', 'type': 'e', 'parammaps': {
            id: '@insertSpotList.id',
            pastureid: '@insertSpotList.pastureid'
          }}
          ExecDataByConfig(this.requestParam).then(response => {
            console.log('删除保存发送参数', this.requestParam)
            if (response.msg === 'fail') {
              this.$notify({ title: '删除失败', message: response.data, type: 'warning', duration: 2000 })
            } else {
              this.$notify({ title: '', message: '删除成功', type: 'success', duration: 2000 })
              this.getList()
            }
          })
        })
      }
    },
     // 改成多条，后端接口未改正确，先注释
     handleCopy() {
      console.log('点击了复制')
      if (this.selectList.length == 0) {
        this.$message({ type: 'error', message: '请选择粪便筛', duration: 2000 })
      } else  {
        MessageBox.confirm('是否确认复制此信息?', {
          confirmButtonText: '确认', cancelButtonText: '取消', type: 'warning'
        }).then(() => {

          var send_data = {
            "common":{"returnmap":"0"},
            "data":[
              {
                "name":"insertSpotList",
                "resultmaps":{
                  "list":this.selectList
                },
                "children":[
                    {
                      "name":"copyDungsieve","type":"e",
                      "parammaps":{
                        "id": "@insertSpotList.id",
                        "pastureid":"@insertSpotList.pastureid"
                      }
                    }
                ]
              }
            ]
          }
          ExecDataByConfig(send_data).then(response => {
            if (response.msg === 'fail') {
              this.$notify({ title: '保存失败', message: response.data, type: 'warning', duration: 2000 })
            } else {
              this.$notify({ title: '成功', message: '保存成功', type: 'success', duration: 2000 })
              this.getList()
            }
          })
        }).catch(() => {
          this.$message({ type: 'info', message: '已取消复制' })
        })
      }
    },
    // 导出
    handleExport(item) {
      if (item == 1) {
        console.log('点击了导出模板')
        const requestParam = this.requestParam
        const url = Cookies.get('url') + 'file/导入导出模板/栏舍生产/粪便筛导入模板.xlsx' // 请求下载文件的地址
        console.log(url)
        axios({
          method: 'GET',
          url: url,
          data: requestParam,
          headers: { token: getToken(), optname: 'insertcustomdoc' },
          responseType: 'blob'
        }).then(res => {
          if (!res) return
          this.percentage = 99
          setTimeout(() => {
            this.isPercentage = false
          }, 2000)
          const blob = new Blob([res.data], {
            type: 'application/octet-stream;charset=utf-8'
          })
          const url = window.URL.createObjectURL(blob)
          const aLink = document.createElement('a')
          aLink.style.display = 'none'
          aLink.href = url
          const docname = '粪便筛导入模板.xlsx'
          aLink.setAttribute('download', docname) // 下载的文件
          document.body.appendChild(aLink)
          aLink.click()
          document.body.removeChild(aLink)
          window.URL.revokeObjectURL(url)
        })
      } else {
        console.log('点击了导出数据')
        this.download.getdataListParm.parammaps = this.table.getdataListParm.parammaps
        if (this.download.getdataListParm.parammaps.inputDatetime !== '' && this.download.getdataListParm.parammaps.inputDatetime !== null) {
          this.download.getdataListParm.parammaps.startTime = parseTime(this.download.getdataListParm.parammaps.inputDatetime[0], '{y}-{m}-{d}')
          this.download.getdataListParm.parammaps.stopTime = parseTime(this.download.getdataListParm.parammaps.inputDatetime[1], '{y}-{m}-{d}')
        } else {
          this.download.getdataListParm.parammaps.inputDatetime = ''
          this.download.getdataListParm.parammaps.startTime = ''
          this.download.getdataListParm.parammaps.stopTime = ''
        }
        GetDataByName(this.download.getdataListParm).then(response => {
          if (response.data.list !== null) {
            this.download.list = response.data.list
          } else {
            this.download.list = []
          }
          var excelDatas = [
            {
              tHeader: ['栏舍名称', '第一层比例（%）', '第一层重量（g）', '第二层比例（%）', '第二层重量（g）', '第三层比例（%）', '第三层重量（g）', '备注', '操作人', '操作日期'],
              filterVal: ['barname', 'onerate', 'oneweight', 'tworate', 'twoweight', 'threerate', 'threeweight', 'remark', 'emp', 'operatetime'],
              tableDatas: this.download.list,
              sheetName: 'Sheet1'
            }
          ]
          json2excel(excelDatas, '粪便筛', true, 'xlsx')
        })
      }
    },

    beforeImport(file) {
      const isLt2M = file.size / 1024 / 1024 < 2
      if (!isLt2M) {
        this.$message.error('上传文件大小不能超过 2MB!')
      }
      return isLt2M
    },
    handleImportSuccess(res, file) {
      this.getList()
      if (res.msg === 'ok') {
        this.$message({ title: '成功', message: '导入成功:' + res.data.success + '条!', type: 'success', duration: 2000 })
        if (res.data.err_count > 0) {
          this.$notify({ title: '失败', message: '导入失败:' + res.data.err_count + '条!', type: 'danger', duration: 2000 })
           import('@/vendor/Export2Excel').then(excel => {
             const list1 = res.data.result
             const tHeader = [
               '栏舍名称', '第一层重量（g）', '第二层重量（g）', '第三层重量（g）', '备注', '操作人', '操作日期', '错误信息'
             ]
             const filterVal = [
               '栏舍名称', '第一层重量（g）', '第二层重量（g）', '第三层重量（g）', '备注', '操作人', '操作日期', 'error_msg'
             ]
             const data1 = this.formatJson(filterVal, list1)
             excel.export_json_to_excel({ header: tHeader, data: data1, filename: '粪便筛导入报错信息', autoWidth: true, bookType: 'xlsx' })
           })
        }
      } else {
        this.$notify({ title: '失败', message: '上传失败', type: 'danger', duration: 2000 })
      }
    },
    formatJson(filterVal, jsonData) {
      return jsonData.map(v =>
        filterVal.map(j => {
          if (j === 'timestamp') {
            return parseTime(v[j])
          } else {
            return v[j]
          }
        })
      )
    },
    handleHistoryRecord() {
      console.log('点击历史记录')
      this.dialogFull = false
      this.historyRecord.dialogStatus = 'historyRecord'
      this.historyRecord.dialogFormVisible = true
      const vue = this
      var myComponent = () => import('./historyRecord.vue')
      return vue.historyRecord.myComponent = myComponent
    }

  }
}
</script>
